var sysvar={};
for (var i=1; i<arguments.length; i+=2)
	sysvar[arguments[i]]=arguments[i+1];

if (sysvar.install_dir) install_dir=sysvar.install_dir;

if (global._WIN32)
	os.makedirs(install_dir);
else
	if (os.system("install -d "+install_dir))
		os.exit(1);

for each (filename in dir()) {
	if (filename.match(/\.js$/) &&
		filename[0]!="." &&
		(filename[0]!="_" || filename=="_resolve.js")) {
		print("Installing "+filename.substr(0,filename.length-3)+"\n");
		if (global._WIN32) {
			if (os.system("copy "+filename+" "+install_dir))
				os.exit(1);
		} else {
			if (os.system("cp "+filename+" "+install_dir))
				os.exit(1);
		}
	}
	if (os.isdir(filename) &&
		filename[0] != ".") {
		print("Installing "+filename+"\n");
		module.install(filename);
	}
}

if (global._WIN32) {
	os.system("copy jsextrc "+install_dir);
} else {
	os.system("install -d "+sysvar.sysconfdir);
	os.system("install jsextrc "+sysvar.sysconfdir+"/jsext.jsextrc-"+sysvar.version);
}
