/*
  Event handler
*/ 

var EvtHandler=function() {}

windows.WM_Names={};
for (var i in Flags.WM)
	windows.WM_Names[Flags.WM[i]]=i;

delete Flags.SC.ICON;
delete Flags.SC.ZOOM;
EvtHandler.prototype.SYSCOMMANDNames={};
for (var i in Flags.SC) {
	EvtHandler.prototype.SYSCOMMANDNames[Flags.SC[i]]=i;
}

EvtHandler.prototype.OnMENUSELECT=function(wParam, lParam) {
	var ID=_.LOWORD(wParam);
	var MenuItem=windows.MenuItems[ID];
	if (MenuItem && MenuItem.OnMENUSELECT)
			return MenuItem.OnMENUSELECT(lParam);
}

EvtHandler.prototype.OnCOMMAND=function(wParam, lParam) {
	var event=_.HIWORD(wParam);
	if (lParam==0 && event==0) { 
		// Menu
		var ID=_.LOWORD(wParam);
		var MenuItem=windows.MenuItems[ID];
		if (MenuItem && MenuItem.OnCOMMAND)
				return MenuItem.OnCOMMAND(lParam);
	} else if (lParam==0 && event==1) { 
		// Accelerator
	} else {
		// Message from control
		var Sender=windows.Windows[lParam];
		if (Sender && Sender.CommandNames) {
			var CommandName=Sender.CommandNames[event];
			var Handler=Sender["On"+CommandName];
			if (Handler)
				return Handler.call(Sender);
		}
	}
}

EvtHandler.prototype.OnNOTIFY=function(ControlID, lParam) {
	var nm=Pointer(_.NMHDR);
	_.memcpy(nm, lParam, _.sizeof(_.NMHDR));
	nm=nm.get();
	var Sender=windows.Windows[Number(nm.hwndFrom)];
	if (Sender && Sender.CommandNames) {
		var CommandName=Sender.CommandNames[nm.code];
		var Handler=Sender["On"+CommandName];
		if (Handler)
			return Handler.call(Sender);
	}
}

EvtHandler.prototype.OnSYSCOMMAND=function(cmdType, lParam) {
	if (this.SYSCOMMANDNames) {
		var SYSCOMMANDName=this.SYSCOMMANDNames[cmdType];
		var Handler=this["On"+SYSCOMMANDName];
		if (Handler)
			return Handler(_.LOWORD(lParam),_.HIWORD(lParam));
	}
}

EvtHandler.prototype.EmptyQueue=function() {
    var msg=_.New(_.MSG);
    while (_.PeekMessage(msg, null, 0, 0, _.PM_REMOVE)) {
		_.TranslateMessage(msg);
	    _.DispatchMessage(msg);
    }
}

EvtHandler.prototype.OneLoop=function() {
    var msg=_.New(_.MSG);
    if (_.GetMessage(msg, null, 0, 0)) {
		_.TranslateMessage(msg);
	    _.DispatchMessage(msg);
		return;
    }
	return msg.wParam;
}

EvtHandler.prototype.MainLoop=function() {
    var msg=_.New(_.MSG);
    while (_.GetMessage(msg, null, 0, 0)) {
		_.TranslateMessage(msg);
	    _.DispatchMessage(msg);
    }
	return msg.wParam;
}

var MsgHandler=function(hwnd, msg, wParam, lParam) {
	var Recipient=windows.Windows[Number(hwnd)];
	var ret=undefined;
	if (Recipient) {
		var Msgname=windows.WM_Names[msg];
		if (Msgname) {
			var Handler=Recipient["On"+Msgname];
			if (Handler) {
				ret=Handler.call(Recipient, wParam, lParam);
				if (ret!==undefined)
					return ret;
			}
		}
	}
	return _.DefWindowProc(hwnd, msg, wParam, lParam);
}

MsgHandler.CallbackPointer=Pointer(MsgHandler);
