var MenuHandles={};
var MenuItems={};

function MenuItem(Options) {
	Options.Mask=0;
	if (Options.bmpChecked!=undefined &&
		Options.bmpUnchecked!=undefined)
		Options.Mask |= _.MIIM_CHECKMARKS;
	if (Options.ItemData!=undefined)
		Options.Mask |= _.MIIM_DATA;
	if (Options.ID!=undefined)
		Options.Mask |= _.MIIM_ID;
	if (Options.State!=undefined)
		Options.Mask |= _.MIIM_STATE;
	if (Options.SubMenu!=undefined)
		Options.Mask |= _.MIIM_SUBMENU;
	if (Options.BITMAP!=undefined) {
		Options.Mask |= _.MIIM_TYPE;
		Options.TypeData=Options.BITMAP;
		Options.BITMAP=true;
	} else if (Options.STRING!=undefined) {
		Options.Mask |= _.MIIM_TYPE;
		Options.TypeData=Options.STRING;
		Options.ch=Options.STRING.length;
		Options.STRING=true;
	}

	Options=windows.MergeOptions(Options,{
		ID: 0,
		SubMenu: null,
		bmpChecked: null,
		bmpUnchecked: null,
		ItemData: 0,
		TypeData: null,
		ch: 0
	}, {
		Type: windows.Flags.MFT,
		State: windows.Flags.MFS
	});

	if (Options.SubMenu) {
		this.SubMenu=new windows.Menu(Options.SubMenu);
	}

	var ret={
		cbSize: _.sizeof(_.MENUITEMINFO),
		fMask: Options.Mask,
		fType: Options.Type,
        fState: Options.State,
        wID: Number(Options.ID),
		hSubMenu: this.SubMenu?this.SubMenu.Menu:null,
		hbmpChecked: Options.bmpChecked,
		hbmpUnchecked: Options.bmpUnchecked,
		dwItemData: Options.ItemData,
		dwTypeData: Options.TypeData,
        cch: Options.ch,
		OnCOMMAND: Options.OnCOMMAND,
		OnMENUSELECT: Options.OnMENUSELECT
	}

	return ret;
}

function Menu(OptionArray) {
	this.Menu=_.CreateMenu();
	windows.MenuHandles[Number(this.Menu)]=this;

	if (OptionArray!=undefined) {
		for (var i in OptionArray) {
			this.Insert(i, OptionArray[i]);
		}
	}
}

Menu.NextID=1;

Menu.prototype.Insert=function(Position, Options) {
	var ID=windows.Menu.NextID++;
	Options.ID=ID;
	var Item=MenuItem(Options);
	if (!_.InsertMenuItem(
		this.Menu,
		Position,
		true,
		Item
	)) throw("Menu.Insert: "+windows.ErrorMessage());
	windows.MenuItems[ID]=Item;
}
