#define WIN32_LEAN_AND_MEAN
#define UNICODE
#define NO_STRICT

#include <windows.h>
#include <commdlg.h>
#include <wingdi.h>
#include <winbase.h>
#include <commctrl.h>
#include <shlwapi.h>
#include <winuser.h>
#include <winreg.h>
#include <richedit.h>

#pragma JSEXT dl "user32.dll"
#pragma JSEXT dl "gdi32.dll"
#pragma JSEXT dl "comdlg32.dll"
#pragma JSEXT dl "kernel32.dll"
#pragma JSEXT dl "comctl32.dll"
#pragma JSEXT dl "msimg32.dll"
#pragma JSEXT dl "mpr.dll"
#pragma JSEXT dl "advapi32.dll"
#pragma JSEXT dl "imm32.dll"
#pragma JSEXT dl "version.dll"
#pragma JSEXT dl "opengl32.dll"
#pragma JSEXT dl "shlwapi.dll"

// The original macros LOWORD and LOBYTE rely on typecasting, which does
// not fly with jsext

#undef LOWORD
#define LOWORD(x) ((x)&0xffff)
#undef LOBYTE
#define LOBYTE(x) ((x)&0xff)

// The following functions are defined in the main program

HINSTANCE JSEXT_get_hInstance(void);
HINSTANCE JSEXT_get_hPrevInstance(void);
char *JSEXT_get_lpCmdLine(void);
int JSEXT_get_nCmdShow(void);

#pragma JSEXT dl main
