/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse ctoxml_cparse
#define yylex   ctoxml_clex
#define yyerror ctoxml_cerror
#define yylval  ctoxml_clval
#define yychar  ctoxml_cchar
#define yydebug ctoxml_cdebug
#define yynerrs ctoxml_cnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     CONSTANT = 259,
     STRING_LITERAL = 260,
     SIZEOF = 261,
     PTR_OP = 262,
     INC_OP = 263,
     DEC_OP = 264,
     LEFT_OP = 265,
     RIGHT_OP = 266,
     LE_OP = 267,
     GE_OP = 268,
     EQ_OP = 269,
     NE_OP = 270,
     AND_OP = 271,
     OR_OP = 272,
     MUL_ASSIGN = 273,
     DIV_ASSIGN = 274,
     MOD_ASSIGN = 275,
     ADD_ASSIGN = 276,
     SUB_ASSIGN = 277,
     LEFT_ASSIGN = 278,
     RIGHT_ASSIGN = 279,
     AND_ASSIGN = 280,
     XOR_ASSIGN = 281,
     OR_ASSIGN = 282,
     TYPE_NAME = 283,
     ASM = 284,
     DECLSPEC = 285,
     STDCALL = 286,
     CDECL = 287,
     TYPEDEF = 288,
     EXTERN = 289,
     STATIC = 290,
     AUTO = 291,
     REGISTER = 292,
     INLINE = 293,
     CHAR = 294,
     SHORT = 295,
     INT = 296,
     INT64 = 297,
     LONG = 298,
     SIGNED = 299,
     UNSIGNED = 300,
     FLOAT = 301,
     DOUBLE = 302,
     CONST = 303,
     VOLATILE = 304,
     VOID = 305,
     VA = 306,
     STRUCT = 307,
     UNION = 308,
     ENUM = 309,
     ELIPSIS = 310,
     RANGE = 311,
     CASE = 312,
     DEFAULT = 313,
     IF = 314,
     ELSE = 315,
     SWITCH = 316,
     WHILE = 317,
     DO = 318,
     FOR = 319,
     GOTO = 320,
     CONTINUE = 321,
     BREAK = 322,
     RETURN = 323
   };
#endif
#define IDENTIFIER 258
#define CONSTANT 259
#define STRING_LITERAL 260
#define SIZEOF 261
#define PTR_OP 262
#define INC_OP 263
#define DEC_OP 264
#define LEFT_OP 265
#define RIGHT_OP 266
#define LE_OP 267
#define GE_OP 268
#define EQ_OP 269
#define NE_OP 270
#define AND_OP 271
#define OR_OP 272
#define MUL_ASSIGN 273
#define DIV_ASSIGN 274
#define MOD_ASSIGN 275
#define ADD_ASSIGN 276
#define SUB_ASSIGN 277
#define LEFT_ASSIGN 278
#define RIGHT_ASSIGN 279
#define AND_ASSIGN 280
#define XOR_ASSIGN 281
#define OR_ASSIGN 282
#define TYPE_NAME 283
#define ASM 284
#define DECLSPEC 285
#define STDCALL 286
#define CDECL 287
#define TYPEDEF 288
#define EXTERN 289
#define STATIC 290
#define AUTO 291
#define REGISTER 292
#define INLINE 293
#define CHAR 294
#define SHORT 295
#define INT 296
#define INT64 297
#define LONG 298
#define SIGNED 299
#define UNSIGNED 300
#define FLOAT 301
#define DOUBLE 302
#define CONST 303
#define VOLATILE 304
#define VOID 305
#define VA 306
#define STRUCT 307
#define UNION 308
#define ENUM 309
#define ELIPSIS 310
#define RANGE 311
#define CASE 312
#define DEFAULT 313
#define IF 314
#define ELSE 315
#define SWITCH 316
#define WHILE 317
#define DO 318
#define FOR 319
#define GOTO 320
#define CONTINUE 321
#define BREAK 322
#define RETURN 323




/* Copy the first part of user declarations.  */


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 28 "c_gram.y"
typedef union YYSTYPE {
  struct Xml *xml;
  char *str;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 226 "c_gram.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */
#line 51 "c_gram.y"

#include "ctoxml.h"
#include <string.h>
#include <stdlib.h>
extern char *ctoxml_cterm;
extern char *ctoxml_cterm2;
extern int ctoxml_clineno;
extern char *ctoxml_filename;
void ctoxml_cerror (char const *msg);


/* Line 213 of yacc.c.  */
#line 248 "c_gram.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  79
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1662

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  93
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  73
/* YYNRULES -- Number of rules. */
#define YYNRULES  255
/* YYNRULES -- Number of states. */
#define YYNSTATES  430

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   323

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    80,     2,     2,     2,    82,    75,     2,
      69,    70,    76,    77,    74,    78,    73,    81,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    88,    90,
      83,    89,    84,    87,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    71,     2,    72,    85,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    91,    86,    92,    79,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    13,    15,    20,    24,
      29,    33,    37,    40,    43,    45,    49,    51,    54,    57,
      60,    63,    68,    70,    72,    74,    76,    78,    80,    82,
      87,    89,    93,    97,   101,   103,   107,   111,   113,   117,
     121,   123,   127,   131,   135,   139,   141,   145,   149,   151,
     155,   157,   161,   163,   167,   169,   173,   175,   179,   181,
     187,   189,   193,   195,   197,   199,   201,   203,   205,   207,
     209,   211,   213,   215,   217,   221,   223,   226,   230,   235,
     241,   245,   247,   250,   252,   255,   257,   260,   262,   265,
     267,   271,   273,   277,   279,   283,   288,   290,   292,   294,
     296,   298,   300,   302,   304,   306,   308,   310,   312,   314,
     316,   318,   320,   322,   324,   326,   332,   338,   343,   346,
     349,   351,   353,   355,   358,   361,   365,   367,   370,   372,
     375,   377,   381,   383,   386,   390,   395,   401,   407,   414,
     417,   419,   423,   425,   429,   431,   433,   435,   437,   439,
     442,   446,   449,   451,   455,   459,   464,   468,   473,   478,
     480,   483,   487,   490,   492,   494,   498,   502,   507,   511,
     516,   521,   523,   526,   529,   533,   535,   538,   540,   544,
     546,   550,   553,   556,   558,   560,   564,   566,   569,   571,
     573,   576,   580,   583,   587,   591,   596,   599,   603,   607,
     612,   614,   618,   623,   625,   629,   631,   633,   635,   637,
     639,   641,   643,   647,   652,   656,   658,   661,   665,   667,
     670,   672,   674,   677,   680,   682,   685,   691,   699,   705,
     711,   719,   726,   734,   742,   751,   759,   768,   777,   787,
     791,   794,   797,   800,   804,   806,   809,   811,   813,   816,
     820,   824,   829,   831,   833,   835
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     165,     0,    -1,   164,    -1,     4,    -1,     5,    -1,    69,
     113,    70,    -1,    94,    -1,    95,    71,   113,    72,    -1,
      95,    69,    70,    -1,    95,    69,    96,    70,    -1,    95,
      73,   164,    -1,    95,     7,   164,    -1,    95,     8,    -1,
      95,     9,    -1,   111,    -1,    96,    74,   111,    -1,    95,
      -1,     8,    97,    -1,     9,    97,    -1,    98,    99,    -1,
       6,    97,    -1,     6,    69,   145,    70,    -1,    75,    -1,
      76,    -1,    77,    -1,    78,    -1,    79,    -1,    80,    -1,
      97,    -1,    69,   145,    70,    99,    -1,    99,    -1,   100,
      76,    99,    -1,   100,    81,    99,    -1,   100,    82,    99,
      -1,   100,    -1,   101,    77,   100,    -1,   101,    78,   100,
      -1,   101,    -1,   102,    10,   101,    -1,   102,    11,   101,
      -1,   102,    -1,   103,    83,   102,    -1,   103,    84,   102,
      -1,   103,    12,   102,    -1,   103,    13,   102,    -1,   103,
      -1,   104,    14,   103,    -1,   104,    15,   103,    -1,   104,
      -1,   105,    75,   104,    -1,   105,    -1,   106,    85,   105,
      -1,   106,    -1,   107,    86,   106,    -1,   107,    -1,   108,
      16,   107,    -1,   108,    -1,   109,    17,   108,    -1,   109,
      -1,   109,    87,   113,    88,   110,    -1,   110,    -1,    97,
     112,   111,    -1,    89,    -1,    18,    -1,    19,    -1,    20,
      -1,    21,    -1,    22,    -1,    23,    -1,    24,    -1,    25,
      -1,    26,    -1,    27,    -1,   111,    -1,   113,    74,   111,
      -1,   110,    -1,   116,    90,    -1,   116,   117,    90,    -1,
      33,   116,   118,    90,    -1,    33,   116,    74,   118,    90,
      -1,    33,   116,    90,    -1,   121,    -1,   121,   116,    -1,
     122,    -1,   122,   116,    -1,   133,    -1,   133,   116,    -1,
     120,    -1,   120,   116,    -1,   119,    -1,   117,    74,   119,
      -1,   137,    -1,   118,    74,   137,    -1,   135,    -1,   135,
      89,   148,    -1,    30,    69,   164,    70,    -1,    34,    -1,
      35,    -1,    38,    -1,    36,    -1,    37,    -1,    39,    -1,
      40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,    -1,
      45,    -1,    46,    -1,    47,    -1,    50,    -1,    51,    -1,
     123,    -1,   130,    -1,   163,    -1,   124,   164,    91,   125,
      92,    -1,   124,   163,    91,   125,    92,    -1,   124,    91,
     125,    92,    -1,   124,   164,    -1,   124,   163,    -1,    52,
      -1,    53,    -1,   126,    -1,   125,   126,    -1,   127,    90,
      -1,   127,   128,    90,    -1,   122,    -1,   122,   127,    -1,
     133,    -1,   133,   127,    -1,   129,    -1,   128,    74,   129,
      -1,   135,    -1,    88,   114,    -1,   135,    88,   114,    -1,
      54,    91,   131,    92,    -1,    54,   164,    91,   131,    92,
      -1,    54,    91,   131,    74,    92,    -1,    54,   164,    91,
     131,    74,    92,    -1,    54,   164,    -1,   132,    -1,   131,
      74,   132,    -1,   164,    -1,   164,    89,   114,    -1,    48,
      -1,    49,    -1,    32,    -1,    31,    -1,   136,    -1,   139,
     136,    -1,   139,   134,   136,    -1,   134,   135,    -1,   164,
      -1,    69,   135,    70,    -1,   136,    71,    72,    -1,   136,
      71,   114,    72,    -1,   136,    69,    70,    -1,   136,    69,
     141,    70,    -1,   136,    69,   144,    70,    -1,   136,    -1,
     139,   138,    -1,   139,   134,   138,    -1,   134,   135,    -1,
     164,    -1,   163,    -1,    69,   137,    70,    -1,   138,    71,
      72,    -1,   138,    71,   114,    72,    -1,   138,    69,    70,
      -1,   138,    69,   141,    70,    -1,   138,    69,   144,    70,
      -1,    76,    -1,    76,   140,    -1,    76,   139,    -1,    76,
     140,   139,    -1,   133,    -1,   140,   133,    -1,   142,    -1,
     142,    74,    55,    -1,   143,    -1,   142,    74,   143,    -1,
     116,   135,    -1,   116,   146,    -1,   116,    -1,   164,    -1,
     144,    74,   164,    -1,   127,    -1,   127,   146,    -1,   139,
      -1,   147,    -1,   139,   147,    -1,    69,   146,    70,    -1,
      71,    72,    -1,    71,   114,    72,    -1,   147,    71,    72,
      -1,   147,    71,   114,    72,    -1,    69,    70,    -1,    69,
     141,    70,    -1,   147,    69,    70,    -1,   147,    69,   141,
      70,    -1,   111,    -1,    91,   149,    92,    -1,    91,   149,
      74,    92,    -1,   148,    -1,   149,    74,   148,    -1,   151,
      -1,   153,    -1,   156,    -1,   157,    -1,   158,    -1,   159,
      -1,   152,    -1,   164,    88,   150,    -1,    57,   114,    88,
     150,    -1,    58,    88,   150,    -1,    29,    -1,    91,    92,
      -1,    91,   155,    92,    -1,   115,    -1,   154,   115,    -1,
     115,    -1,   150,    -1,   155,   150,    -1,   155,   115,    -1,
      90,    -1,   113,    90,    -1,    59,    69,   113,    70,   150,
      -1,    59,    69,   113,    70,   150,    60,   150,    -1,    61,
      69,   113,    70,   150,    -1,    62,    69,   113,    70,   150,
      -1,    63,   150,    62,    69,   113,    70,    90,    -1,    64,
      69,    90,    90,    70,   150,    -1,    64,    69,    90,    90,
     113,    70,   150,    -1,    64,    69,    90,   113,    90,    70,
     150,    -1,    64,    69,    90,   113,    90,   113,    70,   150,
      -1,    64,    69,   113,    90,    90,    70,   150,    -1,    64,
      69,   113,    90,    90,   113,    70,   150,    -1,    64,    69,
     113,    90,   113,    90,    70,   150,    -1,    64,    69,   113,
      90,   113,    90,   113,    70,   150,    -1,    65,   164,    90,
      -1,    66,    90,    -1,    67,    90,    -1,    68,    90,    -1,
      68,   113,    90,    -1,   161,    -1,   160,   161,    -1,   162,
      -1,   115,    -1,   135,   153,    -1,   135,   154,   153,    -1,
     116,   135,   153,    -1,   116,   135,   154,   153,    -1,    28,
      -1,     3,    -1,   160,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    65,    65,    66,   100,   101,   105,   106,   107,   108,
     109,   110,   111,   112,   116,   117,   121,   122,   123,   124,
     125,   126,   130,   131,   132,   133,   134,   135,   139,   140,
     144,   145,   146,   147,   151,   152,   153,   157,   158,   159,
     163,   164,   165,   166,   167,   171,   172,   173,   177,   178,
     182,   183,   187,   188,   192,   193,   197,   198,   202,   203,
     207,   208,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   226,   227,   231,   235,   236,   237,   238,
     239,   243,   244,   245,   246,   247,   248,   249,   250,   254,
     255,   259,   260,   264,   265,   269,   273,   274,   275,   276,
     277,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   298,   299,   300,   301,   302,
     306,   307,   311,   312,   316,   317,   321,   322,   323,   324,
     328,   329,   333,   334,   335,   339,   340,   341,   342,   343,
     347,   348,   352,   353,   357,   358,   362,   363,   367,   368,
     369,   370,   374,   375,   376,   377,   378,   379,   380,   384,
     385,   386,   387,   391,   392,   393,   394,   395,   396,   397,
     398,   402,   403,   404,   405,   409,   410,   414,   415,   419,
     420,   424,   425,   426,   430,   431,   435,   436,   440,   441,
     442,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     458,   459,   460,   464,   465,   469,   470,   471,   472,   473,
     474,   475,   479,   480,   481,   485,   489,   490,   494,   495,
     499,   500,   501,   502,   506,   507,   511,   512,   513,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   530,
     531,   532,   533,   534,   538,   539,   543,   544,   548,   549,
     550,   551,   555,   559,   563,   564
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "CONSTANT",
  "STRING_LITERAL", "SIZEOF", "PTR_OP", "INC_OP", "DEC_OP", "LEFT_OP",
  "RIGHT_OP", "LE_OP", "GE_OP", "EQ_OP", "NE_OP", "AND_OP", "OR_OP",
  "MUL_ASSIGN", "DIV_ASSIGN", "MOD_ASSIGN", "ADD_ASSIGN", "SUB_ASSIGN",
  "LEFT_ASSIGN", "RIGHT_ASSIGN", "AND_ASSIGN", "XOR_ASSIGN", "OR_ASSIGN",
  "TYPE_NAME", "ASM", "DECLSPEC", "STDCALL", "CDECL", "TYPEDEF", "EXTERN",
  "STATIC", "AUTO", "REGISTER", "INLINE", "CHAR", "SHORT", "INT", "INT64",
  "LONG", "SIGNED", "UNSIGNED", "FLOAT", "DOUBLE", "CONST", "VOLATILE",
  "VOID", "VA", "STRUCT", "UNION", "ENUM", "ELIPSIS", "RANGE", "CASE",
  "DEFAULT", "IF", "ELSE", "SWITCH", "WHILE", "DO", "FOR", "GOTO",
  "CONTINUE", "BREAK", "RETURN", "'('", "')'", "'['", "']'", "'.'", "','",
  "'&'", "'*'", "'+'", "'-'", "'~'", "'!'", "'/'", "'%'", "'<'", "'>'",
  "'^'", "'|'", "'?'", "':'", "'='", "';'", "'{'", "'}'", "$accept",
  "primary_expr", "postfix_expr", "argument_expr_list", "unary_expr",
  "unary_operator", "cast_expr", "multiplicative_expr", "additive_expr",
  "shift_expr", "relational_expr", "equality_expr", "and_expr",
  "exclusive_or_expr", "inclusive_or_expr", "logical_and_expr",
  "logical_or_expr", "conditional_expr", "assignment_expr",
  "assignment_operator", "expr", "constant_expr", "declaration",
  "declaration_specifiers", "init_declarator_list", "declarator_list2",
  "init_declarator", "declspec", "storage_class_specifier",
  "type_specifier", "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_specifier", "enumerator_list", "enumerator",
  "type_qualifier", "callspec", "declarator", "direct_declarator",
  "declarator2", "direct_declarator2", "pointer", "type_qualifier_list",
  "parameter_type_list", "parameter_list", "parameter_declaration",
  "identifier_list", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "statement", "labeled_statement", "asm_statement", "compound_statement",
  "declaration_list", "statement_list", "expression_statement",
  "selection_statement", "iteration_statement", "jump_statement",
  "translation_unit", "external_definition", "function_definition",
  "typedeffed_name", "identifier", "file", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,    40,
      41,    91,    93,    46,    44,    38,    42,    43,    45,   126,
      33,    47,    37,    60,    62,    94,   124,    63,    58,    61,
      59,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    93,    94,    94,    94,    94,    95,    95,    95,    95,
      95,    95,    95,    95,    96,    96,    97,    97,    97,    97,
      97,    97,    98,    98,    98,    98,    98,    98,    99,    99,
     100,   100,   100,   100,   101,   101,   101,   102,   102,   102,
     103,   103,   103,   103,   103,   104,   104,   104,   105,   105,
     106,   106,   107,   107,   108,   108,   109,   109,   110,   110,
     111,   111,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   113,   113,   114,   115,   115,   115,   115,
     115,   116,   116,   116,   116,   116,   116,   116,   116,   117,
     117,   118,   118,   119,   119,   120,   121,   121,   121,   121,
     121,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   122,   122,   123,   123,   123,   123,   123,
     124,   124,   125,   125,   126,   126,   127,   127,   127,   127,
     128,   128,   129,   129,   129,   130,   130,   130,   130,   130,
     131,   131,   132,   132,   133,   133,   134,   134,   135,   135,
     135,   135,   136,   136,   136,   136,   136,   136,   136,   137,
     137,   137,   137,   138,   138,   138,   138,   138,   138,   138,
     138,   139,   139,   139,   139,   140,   140,   141,   141,   142,
     142,   143,   143,   143,   144,   144,   145,   145,   146,   146,
     146,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     148,   148,   148,   149,   149,   150,   150,   150,   150,   150,
     150,   150,   151,   151,   151,   152,   153,   153,   154,   154,
     155,   155,   155,   155,   156,   156,   157,   157,   157,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   159,
     159,   159,   159,   159,   160,   160,   161,   161,   162,   162,
     162,   162,   163,   164,   165,   165
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     3,     1,     4,     3,     4,
       3,     3,     2,     2,     1,     3,     1,     2,     2,     2,
       2,     4,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     5,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     3,     4,     5,
       3,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       3,     1,     3,     1,     3,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     5,     4,     2,     2,
       1,     1,     1,     2,     2,     3,     1,     2,     1,     2,
       1,     3,     1,     2,     3,     4,     5,     5,     6,     2,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     2,
       3,     2,     1,     3,     3,     4,     3,     4,     4,     1,
       2,     3,     2,     1,     1,     3,     3,     4,     3,     4,
       4,     1,     2,     2,     3,     1,     2,     1,     3,     1,
       3,     2,     2,     1,     1,     3,     1,     2,     1,     1,
       2,     3,     2,     3,     3,     4,     2,     3,     3,     4,
       1,     3,     4,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     4,     3,     1,     2,     3,     1,     2,
       1,     1,     2,     2,     1,     2,     5,     7,     5,     5,
       7,     6,     7,     7,     8,     7,     8,     8,     9,     3,
       2,     2,     2,     3,     1,     2,     1,     1,     2,     3,
       3,     4,     1,     1,     1,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
     255,   253,   252,     0,   147,   146,     0,    96,    97,    99,
     100,    98,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   144,   145,   110,   111,   120,   121,     0,     0,   171,
     247,     0,    87,    81,    83,   112,     0,   113,    85,     0,
       0,   148,     0,   254,   244,   246,   114,   152,     0,     0,
       0,     0,   139,     0,   175,   173,   172,    76,     0,    89,
      93,    88,    82,    84,     0,   119,   118,    86,   151,     0,
     218,     0,   248,     0,     0,     0,     0,   149,   245,     1,
       0,     0,    80,     0,     0,   159,    91,     0,     0,   140,
     142,     0,   153,   176,   174,     0,    77,     0,   250,     0,
     126,     0,   122,     0,   128,     0,     0,     3,     4,     0,
       0,     0,   215,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,    23,    24,    25,    26,
      27,   224,   216,     6,    16,    28,     0,    30,    34,    37,
      40,    45,    48,    50,    52,    54,    56,    58,    60,    73,
       0,   220,   221,   205,   211,   206,     0,   207,   208,   209,
     210,     2,    93,   219,   249,   156,   183,     0,   177,   179,
       0,   184,   154,    28,    75,     0,     2,   150,    95,     0,
       0,    78,   162,     0,     0,   160,   164,   163,     0,   135,
       0,     0,    90,     0,   200,    94,   251,   127,   117,   123,
       0,   124,     0,   130,   132,   129,     0,     0,     0,    20,
       0,    17,    18,     0,     0,     0,     0,     0,     0,     0,
       0,   240,   241,   242,     0,     0,   186,     0,     0,    12,
      13,     0,     0,     0,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    62,     0,    19,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   225,   217,   223,
     222,     0,     0,     0,   181,   188,   182,   189,   157,     0,
     158,     0,   155,    79,    92,     0,   161,     0,     0,   137,
     141,   143,     0,   136,   203,     0,   133,     0,   125,     0,
     116,   115,     0,     0,   214,     0,     0,     0,     0,     0,
       0,   239,   243,     5,     0,   188,   187,     0,    11,     8,
       0,    14,     0,    10,    61,    31,    32,    33,    35,    36,
      38,    39,    43,    44,    41,    42,    46,    47,    49,    51,
      53,    55,    57,     0,    74,   212,   196,     0,     0,   192,
       0,   190,     0,     0,   178,   180,   185,   165,   168,     0,
       0,   166,     0,   138,     0,   201,   131,   134,    21,   213,
       0,     0,     0,     0,     0,     0,     0,    29,     9,     0,
       7,     0,   197,   191,   193,   198,     0,   194,     0,   169,
     170,   167,   202,   204,   226,   228,   229,     0,     0,     0,
       0,     0,     0,    15,    59,   199,   195,     0,     0,   231,
       0,     0,     0,     0,     0,     0,   227,   230,   232,   233,
       0,   235,     0,     0,     0,   234,   236,   237,     0,   238
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,   133,   134,   320,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   245,
     150,   175,    30,    71,    58,    83,    59,    32,    33,    34,
      35,    36,   101,   102,   103,   202,   203,    37,    88,    89,
      38,    39,    40,    41,    86,   185,    42,    56,   347,   168,
     169,   170,   227,   348,   277,   195,   295,   152,   153,   154,
     155,    73,   156,   157,   158,   159,   160,    43,    44,    45,
      46,   176,    48
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -258
static const short int yypact[] =
{
    1191,  -258,  -258,   -44,  -258,  -258,  1581,  -258,  -258,  -258,
    -258,  -258,  -258,  -258,  -258,  -258,  -258,  -258,  -258,  -258,
    -258,  -258,  -258,  -258,  -258,  -258,  -258,    10,   399,   -16,
    -258,   141,  1581,  1581,  1581,  -258,     7,  -258,  1581,   399,
    1441,    78,   435,  1191,  -258,  -258,  -258,  -258,    64,    89,
      58,    89,    26,    66,  -258,  -258,   -16,  -258,   -53,  -258,
    1414,  -258,  -258,  -258,  1608,    50,    63,  -258,  -258,   506,
    -258,   141,  -258,  1441,  1243,   449,    13,    78,  -258,  -258,
     129,   399,  -258,   -15,   399,    78,  -258,   405,   -36,  -258,
     113,    89,  -258,  -258,  -258,   399,  -258,   679,  -258,  1441,
    1608,  1327,  -258,   132,  1608,  1608,  1608,  -258,  -258,  1041,
    1060,  1060,  -258,  1086,   123,   174,   194,   197,   662,   213,
      89,   137,   183,   696,   852,  -258,  -258,  -258,  -258,  -258,
    -258,  -258,  -258,  -258,   408,   583,  1086,  -258,   -14,   222,
     295,   158,   332,   214,   228,   236,   325,   -10,  -258,  -258,
      71,  -258,  -258,  -258,  -258,  -258,   584,  -258,  -258,  -258,
    -258,   261,   262,  -258,  -258,  -258,   313,   283,   281,  -258,
      -4,  -258,  -258,  -258,  -258,   285,  -258,    78,  -258,    72,
     399,  -258,  -258,   399,   112,   147,  -258,  -258,     5,  -258,
    1086,   -29,  -258,   679,  -258,  -258,  -258,  -258,  -258,  -258,
    1086,  -258,    77,  -258,   277,  -258,  1354,  1381,   852,  -258,
    1086,  -258,  -258,   304,   662,  1086,  1086,  1086,   307,   741,
     303,  -258,  -258,  -258,    79,   120,   -47,   327,    89,  -258,
    -258,   793,  1086,    89,  -258,  -258,  -258,  -258,  -258,  -258,
    -258,  -258,  -258,  -258,  -258,  1086,  -258,  1086,  1086,  1086,
    1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,
    1086,  1086,  1086,  1086,  1086,  1086,  1086,  -258,  -258,  -258,
    -258,   662,  1139,   873,  -258,     9,  -258,   163,  -258,  1553,
    -258,    89,  -258,  -258,  -258,   329,   147,  1295,   904,  -258,
    -258,  -258,     8,  -258,  -258,    45,  -258,   233,  -258,  1086,
    -258,  -258,   333,   662,  -258,   121,   122,   135,   340,   758,
      85,  -258,  -258,  -258,  1472,   166,  -258,  1086,  -258,  -258,
     155,  -258,   264,  -258,  -258,  -258,  -258,  -258,   -14,   -14,
     222,   222,   295,   295,   295,   295,   158,   158,   332,   214,
     228,   236,   325,    54,  -258,  -258,  -258,   342,   348,  -258,
     301,   163,  1516,   930,  -258,  -258,  -258,  -258,  -258,   349,
     204,  -258,   354,  -258,   371,  -258,  -258,  -258,  -258,  -258,
     662,   662,   662,  1086,   951,    86,   774,  -258,  -258,  1086,
    -258,  1086,  -258,  -258,  -258,  -258,   351,  -258,   355,  -258,
    -258,  -258,  -258,  -258,   372,  -258,  -258,   209,   662,   220,
     963,   982,   103,  -258,  -258,  -258,  -258,   662,   344,  -258,
     662,   662,   241,   662,   260,  1008,  -258,  -258,  -258,  -258,
     662,  -258,   662,   662,   269,  -258,  -258,  -258,   662,  -258
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -258,  -258,  -258,  -258,    -3,  -258,  -135,   117,   110,   104,
     127,   175,   178,   179,   180,   181,  -258,   -69,   -88,  -258,
     116,   -11,    56,    14,  -258,   361,   364,  -258,  -258,   290,
    -258,  -258,   282,   -84,   -70,  -258,   159,  -258,   353,  -183,
     300,    43,    55,    23,  -157,   276,   157,  -258,   -72,  -258,
     182,   177,   257,  -147,  -257,  -190,  -258,  -103,  -258,  -258,
     125,   409,  -258,  -258,  -258,  -258,  -258,  -258,   427,  -258,
     -32,     0,  -258
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short int yytable[] =
{
      47,   246,   167,   294,    65,   290,   174,   264,     1,   194,
       1,     1,     1,     1,    31,   218,     1,   199,   351,   276,
      50,    95,   314,   284,   273,    49,   285,    52,    47,    29,
     197,    47,    21,    22,   205,     2,    66,    96,   188,    47,
       4,     5,    47,    47,   174,   292,    61,    62,    63,    80,
      47,    90,    67,   270,   226,   186,   189,    31,   351,   180,
      29,     1,   247,   293,    79,    77,   280,   248,   249,   161,
     281,    47,   173,    85,   171,   181,    47,   265,   272,   316,
     273,    47,    28,    53,    47,    76,    60,   187,   166,     4,
       5,    90,     1,    84,    68,    47,    70,   289,    64,   177,
     363,    51,   213,    47,    85,   194,   209,   211,   212,   290,
     173,   304,   325,   326,   327,     1,    70,    91,   161,   364,
     220,   174,   199,   199,    84,   151,   162,    28,   266,   163,
     184,   174,    81,   173,    29,     1,    92,   365,   226,   182,
       2,   105,   381,   321,     1,   266,   180,    74,    82,    75,
     162,   297,   186,   266,   106,   163,   161,   324,   204,   266,
     266,   267,   283,     4,     5,    72,    47,   298,   345,   312,
     254,   255,     4,     5,   393,   376,   400,   266,   344,   291,
      47,   183,   377,    47,   187,    98,    55,   173,    90,   296,
     313,   370,   371,   415,   266,   266,   266,   173,   164,   178,
     369,    28,   190,    85,   174,   372,    85,    87,    29,   266,
      28,   214,   269,    94,   161,   359,   287,    29,   288,   174,
     200,   274,   201,    84,   196,   378,    84,   221,   318,   379,
     174,    57,   352,   323,   353,   314,     1,   273,    87,   224,
     225,   256,   257,   215,   173,   173,   173,   173,   173,   173,
     173,   173,   173,   173,   173,   173,   173,   173,   173,   173,
     173,   173,   350,   216,     4,     5,   217,   394,   395,   396,
     173,   161,    47,   222,   390,    47,   194,   362,   281,   408,
     386,   356,   219,   266,   174,   173,   166,   171,   367,   260,
     410,   403,    90,   166,   266,   409,   173,    47,    77,   250,
     251,   166,    28,   161,   416,   252,   253,   418,   419,    29,
     421,   420,   404,   261,   173,   266,     1,   425,    76,   426,
     427,   200,   262,   275,   225,   429,   225,    53,   166,    54,
     422,   305,   306,   307,   266,   310,   380,    87,   266,   428,
      87,   263,   388,   266,     4,     5,   258,   259,   322,   271,
     173,    97,   204,   278,   100,   279,    93,   282,   332,   333,
     334,   335,   330,   331,   104,   299,   166,   328,   329,   308,
     161,   161,   161,   384,     1,   107,   108,   109,   173,   110,
     111,   343,   272,   315,   273,   336,   337,   206,   207,    29,
     100,   100,   303,   311,   100,   100,   100,   317,   161,   357,
     104,   104,     1,   368,   104,   104,   104,   161,     1,   373,
     161,   161,   382,   161,   100,   228,   229,   230,   383,   389,
     161,   405,   161,   161,   104,   375,   391,   406,   161,   275,
       4,     5,   407,     2,   417,   338,     4,     5,     1,   339,
     124,   340,   179,   341,   191,   342,   125,   126,   127,   128,
     129,   130,     1,   107,   108,   109,   366,   110,   111,   192,
     286,   355,   193,   392,   360,   302,     4,     5,    28,    99,
      78,   315,     0,     0,   183,    29,     0,   231,     0,   232,
       0,   233,     0,     0,     0,     0,     0,     0,     0,   397,
     399,     0,   402,     0,     0,     0,   100,   100,   100,     0,
       0,     0,     0,     0,    28,     0,   104,   104,   104,     1,
     107,   108,   109,     0,   110,   111,   412,   414,   124,     0,
       0,   172,     0,     0,   125,   126,   127,   128,   129,   130,
       0,   424,     0,     0,     2,   112,     3,     0,     0,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,   113,   114,   115,     0,   116,   117,   118,
     119,   120,   121,   122,   123,   124,     0,     0,     0,     0,
       0,   125,   126,   127,   128,   129,   130,     1,   107,   108,
     109,     0,   110,   111,     0,     0,   131,    69,   132,     0,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,     2,   112,     3,     0,     0,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     0,
       0,   113,   114,   115,     0,   116,   117,   118,   119,   120,
     121,   122,   123,   124,     0,     0,     0,     0,     0,   125,
     126,   127,   128,   129,   130,     1,   107,   108,   109,     0,
     110,   111,   244,     0,   131,    69,   268,     0,     0,     0,
       0,     0,     1,   107,   108,   109,     0,   110,   111,     0,
       0,   112,     0,     0,     0,     0,     0,     0,     0,     1,
     107,   108,   109,     0,   110,   111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   113,
     114,   115,     0,   116,   117,   118,   119,   120,   121,   122,
     123,   124,     0,     0,     0,     0,     0,   125,   126,   127,
     128,   129,   130,     0,     1,   107,   108,   109,   124,   110,
     111,     0,   131,    69,   125,   126,   127,   128,   129,   130,
       0,     1,   107,   108,   109,   124,   110,   111,     0,     0,
     193,   125,   126,   127,   128,   129,   130,     1,   107,   108,
     109,     0,   110,   111,     0,     0,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,   107,   108,   109,
       0,   110,   111,     0,     0,     0,     0,     0,     0,     0,
     124,     0,     0,     0,     0,     0,   125,   126,   127,   128,
     129,   130,     0,     0,     0,     0,     0,   124,     0,     0,
       0,   309,     0,   125,   126,   127,   128,   129,   130,     0,
       0,     0,     0,   124,     0,     0,     0,     0,   374,   125,
     126,   127,   128,   129,   130,     1,   107,   108,   109,     0,
     110,   111,   124,   319,   401,     0,     0,     0,   125,   126,
     127,   128,   129,   130,     0,     0,     1,   107,   108,   109,
       2,   110,   111,     0,     0,     0,     0,     0,     0,     0,
       0,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     1,   107,   108,
     109,     0,   110,   111,     0,     0,     0,     0,     0,     0,
       0,   124,     0,     0,     0,     0,     0,   125,   126,   127,
     128,   129,   130,     1,   107,   108,   109,     0,   110,   111,
       0,     0,   124,     0,     0,   349,     0,     0,   125,   126,
     127,   128,   129,   130,     1,   107,   108,   109,     0,   110,
     111,     0,     0,     0,     0,     0,     1,   107,   108,   109,
       0,   110,   111,   124,     0,     0,   361,     0,     0,   125,
     126,   127,   128,   129,   130,     1,   107,   108,   109,     0,
     110,   111,     0,     0,     0,     0,     0,     0,     0,   124,
       0,     0,   387,     0,     0,   125,   126,   127,   128,   129,
     130,     1,   107,   108,   109,     0,   110,   111,     0,     0,
     124,   398,     0,     0,     0,     0,   125,   126,   127,   128,
     129,   130,   124,   411,     0,     0,     0,     0,   125,   126,
     127,   128,   129,   130,     1,   107,   108,   109,     0,   110,
     111,   124,   413,     0,     0,     0,     0,   125,   126,   127,
     128,   129,   130,     1,   107,   108,   109,     0,   110,   111,
       0,     0,     0,     0,     0,     0,     0,   124,   423,     0,
       0,     0,     0,   125,   126,   127,   128,   129,   130,     1,
     107,   108,   109,     0,   110,   111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     208,     0,     0,     0,     0,     0,   125,   126,   127,   128,
     129,   130,     0,     0,     0,     0,     0,     0,     0,   210,
       0,     0,     0,     0,     0,   125,   126,   127,   128,   129,
     130,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   124,     0,     0,     0,     0,
       0,   125,   126,   127,   128,   129,   130,     2,     0,     3,
       4,     5,     0,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     1,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   272,   346,
     273,     0,     0,     0,     0,    29,     0,     0,     0,     2,
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     1,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,    29,     0,     0,
       0,     2,     0,     3,     0,     0,     0,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     1,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   165,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     0,     3,     0,     0,     0,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   358,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     2,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     2,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   198,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,     0,     0,
       0,     0,     2,     0,     3,     0,   300,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     2,
       0,     3,     0,   301,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     0,     0,     0,     0,
       2,     0,     3,    97,     0,    69,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,     0,
       0,     0,    69,     0,     0,     0,     0,     0,     0,     0,
       0,   314,   346,   273,     2,     0,     3,     0,    29,     0,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     0,     3,     0,     0,   385,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,   354,     2,
       0,     3,     0,     0,     0,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     2,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

static const short int yycheck[] =
{
       0,   136,    74,   193,    36,   188,    75,    17,     3,    97,
       3,     3,     3,     3,     0,   118,     3,   101,   275,   166,
       6,    74,    69,   180,    71,    69,   183,    27,    28,    76,
     100,    31,    48,    49,   104,    28,    36,    90,    74,    39,
      31,    32,    42,    43,   113,    74,    32,    33,    34,    49,
      50,    51,    38,   156,   124,    87,    92,    43,   315,    74,
      76,     3,    76,    92,     0,    42,    70,    81,    82,    69,
      74,    71,    75,    50,    74,    90,    76,    87,    69,   226,
      71,    81,    69,    28,    84,    42,    31,    87,    74,    31,
      32,    91,     3,    50,    39,    95,    40,    92,    91,    76,
      92,    91,   113,   103,    81,   193,   109,   110,   111,   292,
     113,   214,   247,   248,   249,     3,    60,    91,   118,    74,
     120,   190,   206,   207,    81,    69,    71,    69,    74,    73,
      87,   200,    74,   136,    76,     3,    70,    92,   208,    84,
      28,    91,    88,   231,     3,    74,    74,    69,    90,    71,
      95,    74,   184,    74,    91,    99,   156,   245,   103,    74,
      74,    90,    90,    31,    32,    40,   166,    90,   271,    90,
      12,    13,    31,    32,   364,    90,    90,    74,   266,   190,
     180,    69,   317,   183,   184,    60,    29,   190,   188,   200,
      70,    70,    70,    90,    74,    74,    74,   200,    73,    70,
     303,    69,    89,   180,   273,    70,   183,    50,    76,    74,
      69,    88,   156,    56,   214,   287,    69,    76,    71,   288,
      88,   166,    90,   180,    99,    70,   183,    90,   228,    74,
     299,    90,    69,   233,    71,    69,     3,    71,    81,   123,
     124,    83,    84,    69,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   273,    69,    31,    32,    69,   370,   371,   372,
     273,   271,   272,    90,    70,   275,   364,   288,    74,    70,
     352,   281,    69,    74,   353,   288,   272,   287,   299,    75,
      70,   379,   292,   279,    74,   398,   299,   297,   275,    77,
      78,   287,    69,   303,   407,    10,    11,   410,   411,    76,
     413,    70,   381,    85,   317,    74,     3,   420,   275,   422,
     423,    88,    86,   166,   208,   428,   210,   272,   314,    29,
      70,   215,   216,   217,    74,   219,    72,   180,    74,    70,
     183,    16,   353,    74,    31,    32,    14,    15,   232,    88,
     353,    89,   297,    70,    64,    74,    56,    72,   254,   255,
     256,   257,   252,   253,    64,    88,   352,   250,   251,    62,
     370,   371,   372,    72,     3,     4,     5,     6,   381,     8,
       9,   265,    69,   226,    71,   258,   259,   105,   106,    76,
     100,   101,    88,    90,   104,   105,   106,    70,   398,    70,
     100,   101,     3,    70,   104,   105,   106,   407,     3,    69,
     410,   411,    70,   413,   124,     7,     8,     9,    70,    70,
     420,    70,   422,   423,   124,   309,    72,    72,   428,   272,
      31,    32,    60,    28,    90,   260,    31,    32,     3,   261,
      69,   262,    81,   263,    91,   264,    75,    76,    77,    78,
      79,    80,     3,     4,     5,     6,   297,     8,     9,    95,
     184,   279,    91,    92,   287,   208,    31,    32,    69,    60,
      43,   314,    -1,    -1,    69,    76,    -1,    69,    -1,    71,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
     374,    -1,   376,    -1,    -1,    -1,   206,   207,   208,    -1,
      -1,    -1,    -1,    -1,    69,    -1,   206,   207,   208,     3,
       4,     5,     6,    -1,     8,     9,   400,   401,    69,    -1,
      -1,    72,    -1,    -1,    75,    76,    77,    78,    79,    80,
      -1,   415,    -1,    -1,    28,    29,    30,    -1,    -1,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,     3,     4,     5,
       6,    -1,     8,     9,    -1,    -1,    90,    91,    92,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    28,    29,    30,    -1,    -1,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    80,     3,     4,     5,     6,    -1,
       8,     9,    89,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,    -1,     8,     9,    -1,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,    -1,     8,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    80,    -1,     3,     4,     5,     6,    69,     8,
       9,    -1,    90,    91,    75,    76,    77,    78,    79,    80,
      -1,     3,     4,     5,     6,    69,     8,     9,    -1,    -1,
      91,    75,    76,    77,    78,    79,    80,     3,     4,     5,
       6,    -1,     8,     9,    -1,    -1,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
      -1,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,
      -1,    90,    -1,    75,    76,    77,    78,    79,    80,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    90,    75,
      76,    77,    78,    79,    80,     3,     4,     5,     6,    -1,
       8,     9,    69,    70,    90,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    -1,     3,     4,     5,     6,
      28,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,     3,     4,     5,
       6,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    80,     3,     4,     5,     6,    -1,     8,     9,
      -1,    -1,    69,    -1,    -1,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,     3,     4,     5,     6,    -1,     8,
       9,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
      -1,     8,     9,    69,    -1,    -1,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,     3,     4,     5,     6,    -1,
       8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      -1,    -1,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,     3,     4,     5,     6,    -1,     8,     9,    -1,    -1,
      69,    70,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    69,    70,    -1,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,     3,     4,     5,     6,    -1,     8,
       9,    69,    70,    -1,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    80,     3,     4,     5,     6,    -1,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    -1,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    80,     3,
       4,     5,     6,    -1,     8,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      80,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    28,    -1,    30,
      31,    32,    -1,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    28,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,    -1,
      -1,    28,    -1,    30,    -1,    -1,    -1,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    30,    -1,    -1,    -1,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    30,    -1,    92,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    28,
      -1,    30,    -1,    92,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      28,    -1,    30,    89,    -1,    91,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    70,    71,    28,    -1,    30,    -1,    76,    -1,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    30,    -1,    -1,    70,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    28,
      -1,    30,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    28,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    69,    76,
     115,   116,   120,   121,   122,   123,   124,   130,   133,   134,
     135,   136,   139,   160,   161,   162,   163,   164,   165,    69,
     116,    91,   164,   135,   133,   139,   140,    90,   117,   119,
     135,   116,   116,   116,    91,   163,   164,   116,   135,    91,
     115,   116,   153,   154,    69,    71,   134,   136,   161,     0,
     164,    74,    90,   118,   134,   136,   137,   139,   131,   132,
     164,    91,    70,   133,   139,    74,    90,    89,   153,   154,
     122,   125,   126,   127,   133,    91,    91,     4,     5,     6,
       8,     9,    29,    57,    58,    59,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    75,    76,    77,    78,    79,
      80,    90,    92,    94,    95,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     113,   115,   150,   151,   152,   153,   155,   156,   157,   158,
     159,   164,   135,   115,   153,    70,   116,   141,   142,   143,
     144,   164,    72,    97,   110,   114,   164,   136,    70,   118,
      74,    90,   135,    69,   134,   138,   163,   164,    74,    92,
      89,   131,   119,    91,   111,   148,   153,   127,    92,   126,
      88,    90,   128,   129,   135,   127,   125,   125,    69,    97,
      69,    97,    97,   114,    88,    69,    69,    69,   150,    69,
     164,    90,    90,    90,   113,   113,   127,   145,     7,     8,
       9,    69,    71,    73,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    89,   112,    99,    76,    81,    82,
      77,    78,    10,    11,    12,    13,    83,    84,    14,    15,
      75,    85,    86,    16,    17,    87,    74,    90,    92,   115,
     150,    88,    69,    71,   135,   139,   146,   147,    70,    74,
      70,    74,    72,    90,   137,   137,   138,    69,    71,    92,
     132,   114,    74,    92,   148,   149,   114,    74,    90,    88,
      92,    92,   145,    88,   150,   113,   113,   113,    62,    90,
     113,    90,    90,    70,    69,   139,   146,    70,   164,    70,
      96,   111,   113,   164,   111,    99,    99,    99,   100,   100,
     101,   101,   102,   102,   102,   102,   103,   103,   104,   105,
     106,   107,   108,   113,   111,   150,    70,   141,   146,    72,
     114,   147,    69,    71,    55,   143,   164,    70,    70,   141,
     144,    72,   114,    92,    74,    92,   129,   114,    70,   150,
      70,    70,    70,    69,    90,   113,    90,    99,    70,    74,
      72,    88,    70,    70,    72,    70,   141,    72,   114,    70,
      70,    72,    92,   148,   150,   150,   150,   113,    70,   113,
      90,    90,   113,   111,   110,    70,    72,    60,    70,   150,
      70,    70,   113,    70,   113,    90,   150,    90,   150,   150,
      70,   150,    70,    70,   113,   150,   150,   150,    70,   150
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 65 "c_gram.y"
    { (yyval.xml) = xml_text("id", 0, (yyvsp[0].str)); }
    break;

  case 3:
#line 66 "c_gram.y"
    { 

    if (ctoxml_cterm[0]=='\'') {
      char txt[20];
      c_unescape(ctoxml_cterm);

      sprintf(txt,"%d",(int)(ctoxml_cterm[0]));
      (yyval.xml) = xml_text("c",0,strdup(txt));
      free(ctoxml_cterm);

    } else {
	  char *attrib=0;
	  char *value=0;
	  if (ctoxml_cterm[0]!='0') {
	    char lc=ctoxml_cterm[strlen(ctoxml_cterm)-1];
	    switch(lc) {
	    case 'f': attrib="length"; value="f"; break;
	    case 'F': attrib="length"; value="F"; break;
	    case 'l': attrib="length"; value="l"; break;
	    case 'L': attrib="length"; value="L"; break;
	    case 'u': attrib="length"; value="u"; break;
	    case 'U': attrib="length"; value="U"; break;
	    }
	    if (lc=='f' || lc=='F' || lc=='l' || lc=='L' || lc=='u' || lc=='U') {
	      ctoxml_cterm[strlen(ctoxml_cterm)-1]=0;
	    }
	  }
	  if (attrib)
	    (yyval.xml) = xml_text("c",attrib,strdup(value),0,ctoxml_cterm);
	  else
	    (yyval.xml) = xml_text("c",0,ctoxml_cterm);
    }
    
}
    break;

  case 4:
#line 100 "c_gram.y"
    { c_unescape(ctoxml_cterm); (yyval.xml) = xml_text("s", 0, ctoxml_cterm); }
    break;

  case 5:
#line 101 "c_gram.y"
    { (yyval.xml) = xml("p",0,(yyvsp[-1].xml),0); }
    break;

  case 6:
#line 105 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 7:
#line 106 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-3].xml),(yyvsp[-1].xml),0); }
    break;

  case 8:
#line 107 "c_gram.y"
    { (yyval.xml) = xml("call",0,(yyvsp[-2].xml),0); }
    break;

  case 9:
#line 108 "c_gram.y"
    { (yyval.xml) = xml("call",0,(yyvsp[-3].xml),(yyvsp[-1].xml),0); }
    break;

  case 10:
#line 109 "c_gram.y"
    { (yyval.xml) = xml("mb",0,(yyvsp[-2].xml),xml_text("id",0,(yyvsp[0].str)),0); }
    break;

  case 11:
#line 110 "c_gram.y"
    { (yyval.xml) = xml("ptr",0,(yyvsp[-2].xml), xml_text("id",0,(yyvsp[0].str)),0); }
    break;

  case 12:
#line 111 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("++"), "post",strdup("1"),0, (yyvsp[-1].xml),0); }
    break;

  case 13:
#line 112 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("--"), "post",strdup("1"),0, (yyvsp[-1].xml),0); }
    break;

  case 14:
#line 116 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 15:
#line 117 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml), (yyvsp[0].xml)); }
    break;

  case 16:
#line 121 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 17:
#line 122 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("++"),"pre",strdup("1"), 0, (yyvsp[0].xml),0); }
    break;

  case 18:
#line 123 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("--"),"pre",strdup("1"), 0, (yyvsp[0].xml),0); }
    break;

  case 19:
#line 124 "c_gram.y"
    { (yyval.xml) = xml("op", "op", strdup((yyvsp[-1].str)), 0, (yyvsp[0].xml),0); }
    break;

  case 20:
#line 125 "c_gram.y"
    { (yyval.xml) = xml("op", "op", strdup("sizeof"), "type",strdup("e"), 0,(yyvsp[0].xml),0); }
    break;

  case 21:
#line 126 "c_gram.y"
    { (yyval.xml) = xml("op", "op", strdup("sizeof"), "type",strdup("t"), 0,(yyvsp[-1].xml),0); }
    break;

  case 22:
#line 130 "c_gram.y"
    { (yyval.str) = "&"; }
    break;

  case 23:
#line 131 "c_gram.y"
    { (yyval.str) = "*"; }
    break;

  case 24:
#line 132 "c_gram.y"
    { (yyval.str) = "+"; }
    break;

  case 25:
#line 133 "c_gram.y"
    { (yyval.str) = "-"; }
    break;

  case 26:
#line 134 "c_gram.y"
    { (yyval.str) = "~"; }
    break;

  case 27:
#line 135 "c_gram.y"
    { (yyval.str) = "!"; }
    break;

  case 28:
#line 139 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 29:
#line 140 "c_gram.y"
    { (yyval.xml) = xml("cast", 0, (yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 30:
#line 144 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 31:
#line 145 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("*"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 32:
#line 146 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("/"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 33:
#line 147 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("%"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 34:
#line 151 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 35:
#line 152 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("+"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 36:
#line 153 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("-"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 37:
#line 157 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 38:
#line 158 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("<<"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 39:
#line 159 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup(">>"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 40:
#line 163 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 41:
#line 164 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("<"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 42:
#line 165 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup(">"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 43:
#line 166 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("<="), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 44:
#line 167 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup(">="), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 45:
#line 171 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 46:
#line 172 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("=="), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 47:
#line 173 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("!="), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 48:
#line 177 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 49:
#line 178 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("&"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 50:
#line 182 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 51:
#line 183 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("^"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 52:
#line 187 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 53:
#line 188 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("|"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 54:
#line 192 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 55:
#line 193 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("&&"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 56:
#line 197 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 57:
#line 198 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("||"), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 58:
#line 202 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 59:
#line 203 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup("?:"), 0,(yyvsp[-4].xml), (yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 60:
#line 207 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 61:
#line 208 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup((yyvsp[-1].str)), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 62:
#line 212 "c_gram.y"
    { (yyval.str) = "="; }
    break;

  case 63:
#line 213 "c_gram.y"
    { (yyval.str) = "*="; }
    break;

  case 64:
#line 214 "c_gram.y"
    { (yyval.str) = "/="; }
    break;

  case 65:
#line 215 "c_gram.y"
    { (yyval.str) = "%="; }
    break;

  case 66:
#line 216 "c_gram.y"
    { (yyval.str) = "+="; }
    break;

  case 67:
#line 217 "c_gram.y"
    { (yyval.str) = "-="; }
    break;

  case 68:
#line 218 "c_gram.y"
    { (yyval.str) = "<<="; }
    break;

  case 69:
#line 219 "c_gram.y"
    { (yyval.str) = ">>="; }
    break;

  case 70:
#line 220 "c_gram.y"
    { (yyval.str) = "&="; }
    break;

  case 71:
#line 221 "c_gram.y"
    { (yyval.str) = "^="; }
    break;

  case 72:
#line 222 "c_gram.y"
    { (yyval.str) = "|="; }
    break;

  case 73:
#line 226 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 74:
#line 227 "c_gram.y"
    { (yyval.xml) = xml("op","op",strdup(","), 0,(yyvsp[-2].xml), (yyvsp[0].xml),0); }
    break;

  case 75:
#line 231 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 76:
#line 235 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[-1].xml), 0); }
    break;

  case 77:
#line 236 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[-2].xml),(yyvsp[-1].xml),0); }
    break;

  case 78:
#line 237 "c_gram.y"
    { (yyval.xml) = xml("d",0,xml("typedef",0,0),(yyvsp[-2].xml),(yyvsp[-1].xml),0); ctoxml_typedef((yyval.xml)); }
    break;

  case 79:
#line 238 "c_gram.y"
    { (yyval.xml) = xml("d",0,xml("typedef",0,0),(yyvsp[-3].xml),(yyvsp[-1].xml),0); ctoxml_typedef((yyval.xml)); }
    break;

  case 80:
#line 239 "c_gram.y"
    { (yyval.xml) = xml("d",0,xml("typedef",0,0),(yyvsp[-1].xml),0); ctoxml_typedef((yyval.xml)); }
    break;

  case 81:
#line 243 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 82:
#line 244 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 83:
#line 245 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 84:
#line 246 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 85:
#line 247 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 86:
#line 248 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 87:
#line 249 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 88:
#line 250 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 89:
#line 254 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 90:
#line 255 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml), (yyvsp[0].xml)); }
    break;

  case 91:
#line 259 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 92:
#line 260 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml), (yyvsp[0].xml)); }
    break;

  case 93:
#line 264 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 94:
#line 265 "c_gram.y"
    { (yyval.xml) = xml("init",0,(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 95:
#line 269 "c_gram.y"
    { (yyval.xml) = xml_text("declspec",0,(yyvsp[-1].str)); }
    break;

  case 96:
#line 273 "c_gram.y"
    { (yyval.xml) = xml("extern",0,0); }
    break;

  case 97:
#line 274 "c_gram.y"
    { (yyval.xml) = xml("static",0,0); }
    break;

  case 98:
#line 275 "c_gram.y"
    { (yyval.xml) = xml("inline",0,0); }
    break;

  case 99:
#line 276 "c_gram.y"
    { (yyval.xml) = xml("auto",0,0); }
    break;

  case 100:
#line 277 "c_gram.y"
    { (yyval.xml) = xml("register",0,0); }
    break;

  case 101:
#line 281 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("char")); }
    break;

  case 102:
#line 282 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("short")); }
    break;

  case 103:
#line 283 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("int")); }
    break;

  case 104:
#line 284 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("__int64")); }
    break;

  case 105:
#line 285 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("long")); }
    break;

  case 106:
#line 286 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("signed")); }
    break;

  case 107:
#line 287 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("unsigned")); }
    break;

  case 108:
#line 288 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("float")); }
    break;

  case 109:
#line 289 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("double")); }
    break;

  case 110:
#line 290 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("void")); }
    break;

  case 111:
#line 291 "c_gram.y"
    { (yyval.xml) = xml_text("t",0,strdup("__builtin_va_list")); }
    break;

  case 112:
#line 292 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 113:
#line 293 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 114:
#line 294 "c_gram.y"
    { (yyval.xml) = xml_text("dt",0,(yyvsp[0].str)); }
    break;

  case 115:
#line 298 "c_gram.y"
    { (yyval.xml) = xml((yyvsp[-4].str),"id",(yyvsp[-3].str),0,(yyvsp[-1].xml),0); }
    break;

  case 116:
#line 299 "c_gram.y"
    { (yyval.xml) = xml((yyvsp[-4].str),"id",(yyvsp[-3].str),0,(yyvsp[-1].xml),0); }
    break;

  case 117:
#line 300 "c_gram.y"
    { (yyval.xml) = xml((yyvsp[-3].str),0,(yyvsp[-1].xml),0); }
    break;

  case 118:
#line 301 "c_gram.y"
    { (yyval.xml) = xml((yyvsp[-1].str),"id",(yyvsp[0].str),0,0); }
    break;

  case 119:
#line 302 "c_gram.y"
    { (yyval.xml) = xml((yyvsp[-1].str),"id",(yyvsp[0].str),0,0); }
    break;

  case 120:
#line 306 "c_gram.y"
    { (yyval.str) = "struct"; }
    break;

  case 121:
#line 307 "c_gram.y"
    { (yyval.str) = "union"; }
    break;

  case 122:
#line 311 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 123:
#line 312 "c_gram.y"
    { (yyval.xml)=xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 124:
#line 316 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[-1].xml),0); }
    break;

  case 125:
#line 317 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[-2].xml),(yyvsp[-1].xml),0); }
    break;

  case 126:
#line 321 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 127:
#line 322 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 128:
#line 323 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 129:
#line 324 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 130:
#line 328 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 131:
#line 329 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml),(yyvsp[0].xml)); }
    break;

  case 132:
#line 333 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 133:
#line 334 "c_gram.y"
    { (yyval.xml) = xml("bitfield",0,(yyvsp[0].xml),0); }
    break;

  case 134:
#line 335 "c_gram.y"
    { (yyval.xml) = xml("bitfield",0,(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 135:
#line 339 "c_gram.y"
    { (yyval.xml) = xml("enum",0,(yyvsp[-1].xml),0); }
    break;

  case 136:
#line 340 "c_gram.y"
    { (yyval.xml) = xml("enum","id",(yyvsp[-3].str),0,(yyvsp[-1].xml),0); }
    break;

  case 137:
#line 341 "c_gram.y"
    { (yyval.xml) = xml("enum",0,(yyvsp[-2].xml),0); }
    break;

  case 138:
#line 342 "c_gram.y"
    { (yyval.xml) = xml("enum","id",(yyvsp[-4].str),0,(yyvsp[-2].xml),0); }
    break;

  case 139:
#line 343 "c_gram.y"
    { (yyval.xml) = xml("enum","id",(yyvsp[0].str),0,0); }
    break;

  case 140:
#line 347 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 141:
#line 348 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml),(yyvsp[0].xml)); }
    break;

  case 142:
#line 352 "c_gram.y"
    { (yyval.xml) = xml_text("id",0,(yyvsp[0].str)); }
    break;

  case 143:
#line 353 "c_gram.y"
    { (yyval.xml) = xml_link(xml_text("id",0,(yyvsp[-2].str)),(yyvsp[0].xml)); }
    break;

  case 144:
#line 357 "c_gram.y"
    { (yyval.xml) = xml("const",0,0); }
    break;

  case 145:
#line 358 "c_gram.y"
    { (yyval.xml) = xml("volatile",0,0); }
    break;

  case 146:
#line 362 "c_gram.y"
    { (yyval.xml) = xml("cdecl",0,0); }
    break;

  case 147:
#line 363 "c_gram.y"
    { (yyval.xml) = xml("stdcall",0,0); }
    break;

  case 148:
#line 367 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 149:
#line 368 "c_gram.y"
    { (yyval.xml) = xml("ptr",0,(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 150:
#line 369 "c_gram.y"
    { (yyval.xml) = xml("ptr",0,(yyvsp[-2].xml),xml_link((yyvsp[-1].xml),(yyvsp[0].xml)),0); }
    break;

  case 151:
#line 370 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 152:
#line 374 "c_gram.y"
    { (yyval.xml) = xml_text("id",0,(yyvsp[0].str)); }
    break;

  case 153:
#line 375 "c_gram.y"
    { (yyval.xml) = xml("p",0,(yyvsp[-1].xml),0); }
    break;

  case 154:
#line 376 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-2].xml),0); }
    break;

  case 155:
#line 377 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-3].xml),(yyvsp[-1].xml),0); }
    break;

  case 156:
#line 378 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-2].xml),xml("pm",0,0),0); }
    break;

  case 157:
#line 379 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-3].xml),xml("pm",0,(yyvsp[-1].xml),0),0); }
    break;

  case 158:
#line 380 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-3].xml),xml("pm",0,(yyvsp[-1].xml),0),0); }
    break;

  case 159:
#line 384 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 160:
#line 385 "c_gram.y"
    { (yyval.xml) = xml("ptr",0,(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 161:
#line 386 "c_gram.y"
    { (yyval.xml) = xml("ptr",0,(yyvsp[-2].xml),xml_link((yyvsp[-1].xml),(yyvsp[0].xml)),0); }
    break;

  case 162:
#line 387 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 163:
#line 391 "c_gram.y"
    { (yyval.xml) = xml_text("id",0,(yyvsp[0].str)); }
    break;

  case 164:
#line 392 "c_gram.y"
    { (yyval.xml) = xml_text("id",0,(yyvsp[0].str)); }
    break;

  case 165:
#line 393 "c_gram.y"
    { (yyval.xml) = xml("p",0,(yyvsp[-1].xml),0); }
    break;

  case 166:
#line 394 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-2].xml),0); }
    break;

  case 167:
#line 395 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-3].xml),(yyvsp[-1].xml),0); }
    break;

  case 168:
#line 396 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-2].xml),xml("pm",0,0),0); }
    break;

  case 169:
#line 397 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-3].xml),xml("pm",0,(yyvsp[-1].xml),0),0); }
    break;

  case 170:
#line 398 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-3].xml),xml("pm",0,(yyvsp[-1].xml),0),0); }
    break;

  case 171:
#line 402 "c_gram.y"
    { (yyval.xml) = xml("a",0,0); }
    break;

  case 172:
#line 403 "c_gram.y"
    { (yyval.xml) = xml("a",0,(yyvsp[0].xml),0); }
    break;

  case 173:
#line 404 "c_gram.y"
    { (yyval.xml) = xml("a",0,(yyvsp[0].xml),0); }
    break;

  case 174:
#line 405 "c_gram.y"
    { (yyval.xml) = xml("a",0,(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 175:
#line 409 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 176:
#line 410 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 177:
#line 414 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 178:
#line 415 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml),xml("elipsis",0,0)); }
    break;

  case 179:
#line 419 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 180:
#line 420 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml),(yyvsp[0].xml)); }
    break;

  case 181:
#line 424 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 182:
#line 425 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 183:
#line 426 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[0].xml),0); }
    break;

  case 184:
#line 430 "c_gram.y"
    { (yyval.xml) = xml_text("id",0,(yyvsp[0].str)); }
    break;

  case 185:
#line 431 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml),xml_text("id",0,(yyvsp[0].str))); }
    break;

  case 186:
#line 435 "c_gram.y"
    { (yyval.xml) = xml("d",0,(yyvsp[0].xml),0); }
    break;

  case 187:
#line 436 "c_gram.y"
    { (yyval.xml) = xml("d",0,xml_link((yyvsp[-1].xml),(yyvsp[0].xml)),0); }
    break;

  case 188:
#line 440 "c_gram.y"
    { (yyval.xml) = xml("ptr",0,(yyvsp[0].xml),0); }
    break;

  case 189:
#line 441 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 190:
#line 442 "c_gram.y"
    { (yyval.xml) = xml("ptr",0,(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 191:
#line 446 "c_gram.y"
    { (yyval.xml) = xml("p",0,(yyvsp[-1].xml),0); }
    break;

  case 192:
#line 447 "c_gram.y"
    { (yyval.xml) = xml("ix",0,0); }
    break;

  case 193:
#line 448 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-1].xml),0); }
    break;

  case 194:
#line 449 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-2].xml),0); }
    break;

  case 195:
#line 450 "c_gram.y"
    { (yyval.xml) = xml("ix",0,(yyvsp[-3].xml),(yyvsp[-1].xml),0); }
    break;

  case 196:
#line 451 "c_gram.y"
    { (yyval.xml) = xml("fd",0,0); }
    break;

  case 197:
#line 452 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-1].xml),0); }
    break;

  case 198:
#line 453 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-2].xml),0); }
    break;

  case 199:
#line 454 "c_gram.y"
    { (yyval.xml) = xml("fd",0,(yyvsp[-3].xml),(yyvsp[-1].xml),0); }
    break;

  case 200:
#line 458 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 201:
#line 459 "c_gram.y"
    { (yyval.xml) = xml("p",0,(yyvsp[-1].xml),0); }
    break;

  case 202:
#line 460 "c_gram.y"
    { (yyval.xml) = xml("p",0,(yyvsp[-2].xml),0); }
    break;

  case 203:
#line 464 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 204:
#line 465 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-2].xml),(yyvsp[0].xml)); }
    break;

  case 205:
#line 469 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 206:
#line 470 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 207:
#line 471 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 208:
#line 472 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 209:
#line 473 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 210:
#line 474 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 211:
#line 475 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 212:
#line 479 "c_gram.y"
    { (yyval.xml) = xml_link(xml_text("label",0,(yyvsp[-2].str)),(yyvsp[0].xml)); }
    break;

  case 213:
#line 480 "c_gram.y"
    { (yyval.xml) = xml_link(xml("case",0,(yyvsp[-2].xml),0),(yyvsp[0].xml)); }
    break;

  case 214:
#line 481 "c_gram.y"
    { (yyval.xml) = xml_link(xml("default",0,0),(yyvsp[0].xml)); }
    break;

  case 215:
#line 485 "c_gram.y"
    { (yyval.xml) = xml_text("asm",0,ctoxml_cterm); }
    break;

  case 216:
#line 489 "c_gram.y"
    { (yyval.xml) = xml("p",0,0); }
    break;

  case 217:
#line 490 "c_gram.y"
    { (yyval.xml) = xml("p",0,(yyvsp[-1].xml),0); }
    break;

  case 218:
#line 494 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 219:
#line 495 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml), (yyvsp[0].xml)); }
    break;

  case 220:
#line 499 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 221:
#line 500 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 222:
#line 501 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 223:
#line 502 "c_gram.y"
    { (yyval.xml) = xml_link((yyvsp[-1].xml),(yyvsp[0].xml)); }
    break;

  case 224:
#line 506 "c_gram.y"
    { (yyval.xml) = xml("e",0,0); }
    break;

  case 225:
#line 507 "c_gram.y"
    { (yyval.xml) = (yyvsp[-1].xml); }
    break;

  case 226:
#line 511 "c_gram.y"
    { (yyval.xml) = xml("if",0,(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 227:
#line 512 "c_gram.y"
    { (yyval.xml) = xml("if",0,(yyvsp[-4].xml),(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 228:
#line 513 "c_gram.y"
    { (yyval.xml) = xml("switch",0,(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 229:
#line 517 "c_gram.y"
    { (yyval.xml) = xml("while",0,(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 230:
#line 518 "c_gram.y"
    { (yyval.xml) = xml("do",0,(yyvsp[-5].xml),5,0); }
    break;

  case 231:
#line 519 "c_gram.y"
    { (yyval.xml) = xml("for",0,xml("e",0,0),xml("e",0,0),xml("e",0,0),(yyvsp[0].xml),0); }
    break;

  case 232:
#line 520 "c_gram.y"
    { (yyval.xml) = xml("for",0,xml("e",0,0),xml("e",0,0),(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 233:
#line 521 "c_gram.y"
    { (yyval.xml) = xml("for",0,xml("e",0,0),(yyvsp[-3].xml),xml("e",0,0),(yyvsp[0].xml),0); }
    break;

  case 234:
#line 522 "c_gram.y"
    { (yyval.xml) = xml("for",0,xml("e",0,0),(yyvsp[-4].xml),(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 235:
#line 523 "c_gram.y"
    { (yyval.xml) = xml("for",0,(yyvsp[-4].xml),xml("e",0,0),xml("e",0,0),(yyvsp[0].xml),0); }
    break;

  case 236:
#line 524 "c_gram.y"
    { (yyval.xml) = xml("for",0,(yyvsp[-5].xml),xml("e",0,0),(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 237:
#line 525 "c_gram.y"
    { (yyval.xml) = xml("for",0,(yyvsp[-5].xml),(yyvsp[-3].xml),xml("e",0,0),(yyvsp[0].xml),0); }
    break;

  case 238:
#line 526 "c_gram.y"
    { (yyval.xml) = xml("for",0,(yyvsp[-6].xml),(yyvsp[-4].xml),(yyvsp[-2].xml),(yyvsp[0].xml),0); }
    break;

  case 239:
#line 530 "c_gram.y"
    { (yyval.xml) = xml_text("goto",0,(yyvsp[-1].str)); }
    break;

  case 240:
#line 531 "c_gram.y"
    { (yyval.xml) = xml("continue",0,0); }
    break;

  case 241:
#line 532 "c_gram.y"
    { (yyval.xml) = xml("break",0,0); }
    break;

  case 242:
#line 533 "c_gram.y"
    { (yyval.xml) = xml("return",0,0); }
    break;

  case 243:
#line 534 "c_gram.y"
    { (yyval.xml) = xml("return",0,(yyvsp[-1].xml),0); }
    break;

  case 244:
#line 538 "c_gram.y"
    { xml_print((yyvsp[0].xml)); xml_free((yyvsp[0].xml)); }
    break;

  case 245:
#line 539 "c_gram.y"
    { xml_print((yyvsp[0].xml)); xml_free((yyvsp[0].xml)); }
    break;

  case 246:
#line 543 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 247:
#line 544 "c_gram.y"
    { (yyval.xml) = (yyvsp[0].xml); }
    break;

  case 248:
#line 548 "c_gram.y"
    { (yyval.xml) = xml("fdef",0,(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 249:
#line 549 "c_gram.y"
    { (yyval.xml) = xml("fdef",0,(yyvsp[-2].xml),(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 250:
#line 550 "c_gram.y"
    { (yyval.xml) = xml("fdef",0,(yyvsp[-2].xml),(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 251:
#line 551 "c_gram.y"
    { (yyval.xml) = xml("fdef",0,(yyvsp[-3].xml),(yyvsp[-2].xml),(yyvsp[-1].xml),(yyvsp[0].xml),0); }
    break;

  case 252:
#line 555 "c_gram.y"
    { (yyval.str) = ctoxml_cterm; }
    break;

  case 253:
#line 559 "c_gram.y"
    { (yyval.str) = ctoxml_cterm; }
    break;

  case 254:
#line 563 "c_gram.y"
    {  }
    break;

  case 255:
#line 564 "c_gram.y"
    {  }
    break;


    }

/* Line 1037 of yacc.c.  */
#line 3149 "c_gram.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 567 "c_gram.y"


#include <stdio.h>

extern int column;

void ctoxml_cerror (char const *msg) {
  fprintf(stderr,"%s:%d: %s\n",ctoxml_filename_errmsg,ctoxml_clineno,msg);
}

