function printf(format) {
        var inner_args=[format].concat(this.printf.prepargs.apply(null,arguments));
        return _.printf.apply(null, inner_args);
}

printf.prepargs=function(format) {
        var inner_args=[];
        var regex=new RegExp("%[#0\\- +'I]*([1-9][0-9]*)?(\\.[0-9]*)?(hh|h|l|ll|L|q|j|z|t)?([diouxXeEfFgGaAcsCSpn])","g");
        for (var i=1;;i++) {
                var match=regex.exec(format);
                if (match==null) break;
                switch(match[4]) {
                        case 'd':
                        case 'i':
                        case 'o':
                        case 'u':
                        case 'x':
                        case 'X':
                                var num=Math.floor(arguments[i]);
                                if (num!=num) throw("Type mismatch"); // NaN
                                inner_args.push(num);
                                break;
                        case 'e':
                        case 'E':
                        case 'f':
                        case 'F':
                        case 'g':
                        case 'G':
                        case 'a':
                        case 'A':
                                inner_args.push(Number(arguments[i])*1.000000000000001);
                                break;
                        case 'c':
                        case 'C':
                                inner_args.push(String(arguments[i]).charCodeAt(0));
                                break;
                        case 's':
                        case 'S':
                                inner_args.push(String(arguments[i]));
                                break;
                        case 'p':
                                if (!arguments[i] instanceof Cobject) {
                                        throw("Type mismatch");
                                }
                                inner_args.push(arguments[i])
                                break;
                        case 'n':
                                if (!arguments[i] instanceof Array) {
                                        throw("Type mismatch");
                                }
                                arguments[i][0]=0;
                                inner_args.push(arguments[i])
                                break;
                }
        }
        return inner_args;
}
